/*
 *  Name: Yinyi Guo 
 *  Section Leader: Ben Phillips
 *
 *  list_completion.cpp
 *  list_completion
 *
 *  Created by Hugo Guo on 2/1/09.
 *  Copyright 2009 Stanford University. All rights reserved.
 *
 */

#include "list_completion.h"
#include <iostream>
#include <string>
#include "genlib.h"
#include <simpio.h>
#include <lexicon.h>
#include "map.h"
#include <strutils.h>
#include "lexicon.h"

void listWords(string prefix)   // this is a function for listing all the possible words
{
	Lexicon lex("lexicon.dat");	
	char init = 'a';
	for (int i=0;i<26;i++) {   // search from 'a' to 'z' in the lexicon
		char letter = init+i;
		string prefix2 = prefix+letter;  // followed by the new letters
		if (lex.containsPrefix(prefix2)) { // first make sure is a legal prefix
			if (lex.containsWord(prefix2)) { // then if is a legal word, just print it!
				cout<< prefix2 <<endl;
			}
			listWords(prefix2);//if it's not a word,try append more letters,because it's a legal prefix
		}
	}
	return;
}


void RecursiveListCompletion(string prefix, string remaining, Map<string>& map, Lexicon& lex)
{
	
	string remaining2, options, nextPrefix;
	if (remaining.size()==0) {        // base case: no more digits
		listWords(nextPrefix);
		return;
	}
	options = map[remaining.substr(0,1)];  // find out the string mapping of the first digit
	remaining2 = remaining.substr(1);      // update the rest digits
	for (int i=0; i< options.size();i++) {  // search those letter one by one for possible words
		nextPrefix = prefix  + options[i];	// 
		if (lex.containsPrefix(nextPrefix)) { // make sure that prefix is legal
			RecursiveListCompletion(nextPrefix, remaining2, map,lex);// do recurssion with update prefix and rest digits
		}
	}
}

void ListCompletions(string digitSeq, Lexicon& lex)
{
	Map<string> map;
	map[IntegerToString(2)] = "abc";     // I use a map for mapping digits to letters
	map[IntegerToString(3)] = "def";
	map[IntegerToString(4)] = "ghi";
	map[IntegerToString(5)] = "jkl";
	map[IntegerToString(6)] = "mno";
	map[IntegerToString(7)] = "pqrs";
	map[IntegerToString(8)] = "tuv";
	map[IntegerToString(9)] = "wxyz";
	RecursiveListCompletion("", digitSeq, map,lex);
}

void main()
{
	while (true) {
		cout << "Give digit sequence: ";
		string digitSeq = GetLine();
		if (digitSeq.size()< 1)
			break;
		Lexicon lex("lexicon.dat");
		ListCompletions(digitSeq,lex);
	}
}
